rm(list=ls())

set.seed(2)

getdir = getwd()
setwd(paste(getdir, "/data", sep=""))

n = 600
beta1f = function(x){
  interf = 0.4 * (exp(2*x - 0.5) - exp(-0.5))
}
beta2f = function(x){
  f1 = 1.3 * x * (0.25 - x)
}
beta3f = function(x){
  f2 = sin(2 * x)
}

lamf = function(x){
  lamf = 4 * x^3
}

dbeta1f = function(x){
  interf= 0.8 * exp(2 * x - 0.5)
}

dbeta2f = function(x){
  df1 = -2.6 * x + 1.3 * 0.25 
}

dbeta3f = function(x){
  df2 = 2 * cos(2* x)
}

x1 = rbinom(n, 1, c(0.5,0.5))
x2 = rbinom(n, 1, c(0.5,0.5))
#x1 = runif(n)
#x2 = runif(n)
x3 = runif(n)

alpha1 = c(2,-2,2)/sqrt(12)
alpha2 = c(2,-2,2)/sqrt(12)
alpha3 = c(2,-2,2)/sqrt(12)

xx = cbind(x1, x2, x3)

z1 = rnorm(n)
z2 = rnorm(n)

w1 = c(xx %*% alpha1)
w2 = c(xx %*% alpha2)
w3 = c(xx %*% alpha3)

etaf = beta1f(w1) + beta2f(w2) * z1 + beta3f(w3) * z2


v = runif(n)
T = (-log(v)/exp(etaf))^(1/4)

CC = runif(n, 1.0, 1.3)
mT = (T <= CC) * T + (T > CC) * CC
print(paste("missing:", mean(T<=CC)))

xdata = xx
zdata = cbind(1, z1, z2)
trunk = rep(0, n)
y = mT
status = (T <= CC)

data1 = list(xdata = xdata, zdata = zdata, trunk = trunk, y = y, delta = status)

GBETAf = cbind(beta1f(w1), beta2f(w2), beta3f(w3))
DGBETAf = cbind(dbeta1f(w1), dbeta2f(w2), dbeta3f(w3))
alphaf = alpha1
aalphaf = alpha2
a3alphaf = alpha3

wf = w1
wwf = w2 
w3wf = w3

data2 = list(GBETAf = GBETAf, DGBETAf = DGBETAf, alphaf = alphaf,
             aalphaf = aalphaf, a3alphaf = a3alphaf, wf = wf,
             wwf = wwf, w3wf = w3wf)


par(mfrow=c(2,2))
plot(wf, GBETAf[,1])
plot(wwf, GBETAf[,2])
plot(w3wf, GBETAf[,3])

save(data1, file = "data1.RData")
save(data2, file = "initial.RData")